<?php
// $Id: kaltura.themeing.inc,v 1.1.2.5.2.3 2011/01/06 10:40:44 xuriz Exp $

/*
 * @file
 * defines all themeing functions for kaltura core module
 *
 */
$GLOBALS['_kaltura_client_folder'] = drupal_get_path('module', 'kaltura') .'/kaltura_client/';

/*
 * helper function that is called in nodeAPI:alter
 *
 * this function gets the content to be displayed,
 * and returns the content with an embed tag instead of a "kaltura tag"
 *
 * some of the return content is a javascript with handler functions for the buttons on the player
 */
function kaltura_replace_tags($content, $is_comment = FALSE, $replace_to_thumb = FALSE, $edit_mix_access = FALSE, $show_embed = FALSE, $content_type = null) {

  global $user, $multibyte;
  $kaltura_editor_width = (variable_get('kaltura_editor_width', ''))? variable_get('kaltura_editor_width', ''): KalturaSettings_SE_WIDTH;
  $kaltura_editor_height = (variable_get('kaltura_editor_height', ''))? variable_get('kaltura_editor_height', ''): KalturaSettings_SE_HEIGHT;
  $kaltura_editor_URL = (variable_get('kaltura_editor_URL', ''))? variable_get('kaltura_editor_URL', ''): KalturaSettings_SE_URL;
  $added_playlist = false;



  $length = drupal_strlen($content);
  // add PHP_EOL before each kaltura widget to ensure correct grep_match results
  $content = str_replace('[kaltura-widget', PHP_EOL .'[kaltura-widget', $content);
  $found = FALSE;
  preg_match_all('/\[kaltura-widget(.*)\/\]/', $content, $matches);
  $kaltura_tags = array();

  foreach ($matches[0] as $key => $match) {

    if (strpos($match, '/][kal', $split_point) === FALSE) {
      $kaltura_tags[] = $matches[0][$key];
      continue;
    }
    $tags = explode('][', $match);
    $splitted = FALSE;
    if (count($tags)) {
      foreach ($tags as $tag_num => $tag) {
        $splitted = TRUE;
        if ($tag[0] != '[') {
          $tags[$tag_num] = '['. $tag;
        }
        if ($tag[drupal_strlen($tag) - 1] != ']') {
          $tags[$tag_num] .= ']';
        }
        $kaltura_tags[] = $tags[$tag_num];
      }
    }
  }

//get the node ID if available - needed to identify node access
/*if ( arg(0) == 'node' && is_numeric(arg(1)) ) {
  $node_id = arg(1);
}*/

  foreach ($kaltura_tags as $kaltura_tag) {

    $found = TRUE;
    // parse the parameters from the tag
    $params = kaltura_get_params_from_tag($kaltura_tag);
    // get the embed options from the params
    $embed_options = kaltura_get_embed_options($params);

    $wid = $embed_options["wid"];
    $width = $embed_options["width"];
    $height = $embed_options["height"];
    $div_id = "kaltura_wrapper_". $wid;
    $thumbnail_div_id = "kaltura_thumbnail_". $wid;
    $player_id = "kaltura_player_". $wid;
    $partner_config = KalturaHelpers::getServiceConfiguration();
    $kaltura_server = (variable_get('kaltura_server_url', ''))? variable_get('kaltura_server_url', ''): KalturaSettings_SERVER_URL;

    $kaltura_poweredby = '<div style="width: '. $width .'px;" class="poweredByKaltura">'.
    '<!--<div><a target="_blank" href="http://drupal.kaltura.org">Video Module</a> by <a target="_blank" href="http://corp.kaltura.com">Kaltura</a></div>-->'.
    '</div>';
    if (variable_get('kaltura_display_credits', 1)) {
      $links = '<a href="http://corp.kaltura.com/download">open source video</a><a href="http://corp.kaltura.com/technology/">video platform</a>';
    }
    if ($replace_to_thumb === TRUE) {
      $html = '<img src="'. $kaltura_server .'/p/'. $partner_config->partnerId .'/sp/'. $partner_config->subPartnerId .'/thumbnail/entry_id/'. $embed_options["media_id"] .'" />';
      $content = str_replace($kaltura_tag, $html, $content);
      continue;
    }

    $embed_textarea_id = "kaltura_embed_".$embed_options["media_id"];
    $div_id = "kaltura_wrapper_". $embed_options["media_id"];
    $player_id = ($embed_options['div_id'])? $embed_options['div_id']: "kaltura_player_". $embed_options["media_id"];
    $align = ($embed_options["align"])? 'text-align:'. $embed_options["align"] .'; ': '';
    if ($is_comment) {
      $thumb_div_id = 'kaltura_thumbnail_'. $embed_options["media_id"];
      $onclick_value = 'kaltura_activate_player(\''. $thumb_div_id .'\',\''. $div_id .'\');';
      $img_tag = '<img src="'. $kaltura_server .'/p/'. $partner_config->partnerId .'/sp/'. $partner_config->subPartnerId .'/thumbnail/entry_id/'. $embed_options["media_id"] .'/width/'. $width .'/height/'. $height .'/type/2/bgcolor/000000/crop_provider/wordpress_comment_placeholder" />';
      $comment_div = '<div id="'. $thumb_div_id .'" class="kaltura_hand" onclick="'. $onclick_value .'">';
      $comment_div .= $img_tag .'</div>';
    }
    else {
      $comment_div = '';
    }


    $html .= $comment_div .'
      <div id="'. $div_id .'" class="kaltura_wrapper" style="'. (($comment_div != '')? 'display:none;':'') . $align . $embed_options['custom_style'] .'"'. $embed_options['js_events'] .'>'. $links .'</div>'. $kaltura_poweredby;
     if ($show_embed) {
       if ($params['media_type'] == 'viewplaylist') $title_class="kaltura_embed_title";
        $html .= '<div class="kaltura_embed_code"><strong class="'.$title_class.'">Embed code of this video:</strong><br /><textarea style="overflow-y:auto" id="'.$embed_textarea_id.'" onclick="javascript:this.focus; this.select();"></textarea></div>';
     }


     //Render KDP
     $html .= '<script type="text/javascript">
              var kaltura_swf = new SWFObject("'. $embed_options["swfUrl"] .'", "'. $player_id .'", "'. $embed_options["width"] .'", "'. $embed_options["height"] .'", "9", "#000000");
              kaltura_swf.addParam("wmode", "opaque");
              kaltura_swf.addParam("flashVars", "'. $embed_options["flashVars"] . (($comment_div != '')? '&autoPlay=true': '') .'");
              kaltura_swf.addParam("allowScriptAccess", "always");
              kaltura_swf.addParam("allowFullScreen", "TRUE");
              kaltura_swf.addParam("allowNetworking", "all");
              kaltura_swf.write("'. $div_id .'");';
        if ($show_embed) {
     $html .= '
                          user_embed_textbox = document.getElementById("'.$embed_textarea_id.'");
                  user_embed_textbox.value = kaltura_swf.getSWFHTML();
                        ';
        }
        if ($params['media_type'] == 'viewplaylist' &&  ($added_playlist == false))
        {
         $added_playlist = true;
     $html .= '
                          function customFunc1(parm) {prev_playlist_item()}
                          function customFunc2(parm) {next_playlist_item();}
                        ';

        }
    $html .= '</script>
    ';



    // rebuild the html with our new code tag
    $content = str_replace($kaltura_tag, $html, $content);
  }

  if ($found && $replace_to_thumb === FALSE) {
    $plugin_url = KalturaHelpers::getKalturaServerUrl();
    $js = '
      <script type="text/javascript">';


     $js .= '
        function onPlayerAddClick (kshowId,entryId,pd_extraData) {
          if (kshowId && kshowId != -1)
            kalturaInitModalBox("'. url("kaltura/contribution_wizard/") .'" + kshowId);
          if (entryId && entryId != -1 && "true" == "'. (($embed_options['roughcut'])? 'true': '') .'")
            kalturaInitModalBox("'. url("kaltura/contribution_wizard/") . (($embed_options['roughcut'])? 'entry-': '') .'" + entryId );
        }';

        $js .= '
        function onPlayerEditClick (kshowId,entryId,pd_extraData) {
          if (kshowId && kshowId != -1 && "true" == "'. (($embed_options['kshow'])? 'true': '') .'")
            kalturaInitModalBox("'. url($kaltura_editor_URL) .'/" + kshowId + "/kshow/user_id@'. $user->uid .'", { width: '.$kaltura_editor_width.', height: '.$kaltura_editor_height.' } );
          if (entryId && entryId != -1 && "true" == "'. (($embed_options['roughcut'])? 'true': '') .'")
            kalturaInitModalBox("'. url($kaltura_editor_URL) .'/" + entryId + "/entry/user_id@'. $user->uid .'", { width: '.$kaltura_editor_width.', height: '.$kaltura_editor_height.' } );
        }';

    //NOTE CM: new KDP v2 Editor handler

    if($edit_mix_access) {
                $js .= '
                        function gotoEditorWindow(entryID) {';

                //If the edit button is pressed on the Drupal node edit page, remind user that they still need to submit the node, especially if it's new, else they won't be able to access their content.
                if (arg(count(arg())-1) == 'edit') {
                        $js .= 'alert("WARNING: Edits are not saved until you submit this form.  You should submit first before editing your mix.");';
                }

                $js .= '
                                kalturaInitModalBox("'. url($kaltura_editor_URL) .'/" + entryID + "/entry/user_id@'. $user->uid .'", { width: '.$kaltura_editor_width.', height: '.$kaltura_editor_height.' });
                        }';
        } else {
                $js .= '
                        function gotoEditorWindow(entryID) {
                                if (entryID) {
                                        window.location = "'.url("kaltura/clone").'/"+entryID+"/'.$content_type.'/confirm";
                                }
                        }';
        }

        $js .= '
        function handleGotoContribWizard (kshowId, pd_extraData) {
          kalturaInitModalBox("'. url("kaltura/contribution_wizard/") .'" + kshowId);
        }';
        /*
        $js .= '
        function handleGotoEditorWindow (kshowId, pd_extraData) {
          kalturaInitModalBox("'. url($kaltura_editor_URL) .'/" + kshowId, { width: 890, height: 546 } );
        }';
   */
   $js .= '</script>';

    $content .= $js;

  }

  return $content;
}

/*
 * helper function that breaks the "kaltura tag" into parameters
 */
function kaltura_get_params_from_tag($tag) {
  $params = array();
  $attributes_array = explode(' ', $tag);
  for ($i = 1, $len = count($attributes_array); $i < $len; $i++) {
    $attr = $attributes_array[$i];
    if (!strpos($attr, "=")) {
      continue;
    }
    $attr = str_replace('"', "", $attr);
    $attr = str_replace("'", "", $attr);
    $keyvalue = explode('=', $attr);
    $key = $keyvalue[0];
    $value = $keyvalue[1];
    $params[$key] = $value;
  }
  return $params;
}


/*
 * callback function for kaltura/contribution_wizard
 *
 * Args is url are a PHP array encoded as JSON and url encoded
 * use kaltura_format_cw_vars() function to convert your array of variables to the correct string
 *
 * this function exposes a hook call kaltura_use_cw which has higer priority then any other option
 *
 * valid list of params: (required params marked with *, values in brackets)
 *   kshow_id* [-2, -1, 0, real_id]
 *   partner_data [free text]
 *   type [entry/null]
 *   context [field/field_mix/comment/null]
 *   field_id
 *   title
 */
 function kaltura_contribution_wizard() {
  global $user;
  $args = func_get_args();
  $temp_args = unserialize(urldecode($args[0]));

  // argument handling

  foreach ($temp_args as $key => $val) {
   ${$key} = $val;
  }

  $temp_ui_conf = kaltura_invoke('use_cw', $temp_args);
  if (!empty($temp_ui_conf[0]))
  {
        $ui_conf = $temp_ui_conf[0];
  }
  $is_entry_node = false;
  if ($kshow_id == -2)
  {
        $is_entry_node = true;
  }

  $kaltura_client = KalturaHelpers::getKalturaClient();

  if (!$kaltura_client) {
    drupal_set_message('Failed to start Kaltura session. Please check your settings.', 'warning');
    echo theme('kaltura_maintenance_page', '<br /><a href="#" onclick="window.top.kalturaCloseModalBox()">Close</a>', TRUE);

   exit;
  }
  /* TODO: remove the creation of RC */

                if (isset($args[1]) && $args[1] != '') {
                  $title = $args[1];
                }

        // create roughcut at this point by API call,
        $session_user = KalturaHelpers::getSessionUser();

        if (empty($partner_data))
        {
                $partner_data = "user_id@". $user->uid;
                $partner_data .= "|kshow_exist@no";
        }

/*      $partner_data = "user_id@". $user->uid;
        $partner_data .= "|kshow_exist@no";
*/
        if ($context == 'field_mix' /*|| $context == 'kaltura_mix' || $context == 'kaltura_entry'*/) {
                $rc = new KalturaMixEntry;
                $rc->name =  $title;
                $rc->userId = $session_user->screenName;
                //$rc->type = ENTRY_TYPE_ROUGHCUT;
                //$rc->tags = $_REQUEST['kaltura_tags'];
                //$rc->adminTags = $_REQUEST['kaltura_admin_tags'];
                $rc->partnerId = variable_get('kaltura_partner_id', '');
                $rc->partner_data = $partner_data;

                //NOTE: CM TO DO - make SIMPLE/ADVANCED variable
                $rc->editorType = KalturaEditorType::ADVANCED;
                $result = $kaltura_client->mixing->add($rc);

                // pass roughcut ID to CW.
                $kshow_id = $result->id;
        }

        //Don't create a node for field_mix
        if ($context != 'field_mix' && $is_entry_node == false && !empty($result)) {
                //NOTE: CM  - add an argument for updates vs. new node. right now this is causing two nodes to be created for every mix..
                kaltura_create_node_from_roughcut($result,1);
  }

  $theme_params->height = 360;
  $theme_params->width = 680;

  if ($context == 'comment')
  {
        $theme_params->swfUrl = KalturaHelpers::getContributionWizardUrl(KalturaSettings_CW_COMMENTS_UICONF_ID);
  }
  else
  {
        if (empty($ui_conf)) // ui_conf was not supplied by external vars (like block button)
        {
                $theme_params->swfUrl = KalturaHelpers::getContributionWizardUrl();
                if (empty($context) && is_entry_node == true) // this is entry
                {
                        $ui_conf = variable_get('kaltura_video_entry_cw_type', '');
                        if (!empty($ui_conf)) //found
                        {
                                if ($ui_conf == 1) // this is custom
                                {
                                        $ui_conf = variable_get('kaltura_video_entry_cw_custom', KalturaSettings_CW_UICONF_ID);
                                }
                                $theme_params->swfUrl = KalturaHelpers::getContributionWizardUrl($ui_conf);
                        }
                }
                else if ($context == 'kaltura_mix')
                {

                        $ui_conf = variable_get('kaltura_mix_roughcut_cw_type', '');
                        if (!empty($ui_conf)) //found
                        {
                                if ($ui_conf == 1) // this is custom
                                {
                                        $ui_conf = variable_get('kaltura_mix_roughcut_cw_custom', KalturaSettings_CW_UICONF_ID);
                                }
                                $theme_params->swfUrl = KalturaHelpers::getContributionWizardUrl($ui_conf);
                        }
                }
        }
        else
        {
                $theme_params->swfUrl = KalturaHelpers::getContributionWizardUrl($ui_conf);
        }
  }

  $simple = false;
  if (KalturaSettings_CW_UICONF_ID_SIMPLE == $ui_conf) $simple=true;

  $flash_vars = KalturaHelpers::getContributionWizardFlashVars($kaltura_client->getKs(), $kshow_id, $partner_data, $type, (($context == 'comment')? TRUE: FALSE), $simple, $ui_conf);
  $theme_params->flashVarsStr = KalturaHelpers::flashVarsToString($flash_vars);

  /*
   *if ($partner_data [>&& strpos($partner_data, 'kshow_exist@no')<]) {
   *  $add_new = TRUE;
   *      $theme_params->mix_id = kaltura_get_node_for_mix($kshow_id);
   *}
   */


  if ($context == 'field' || $context == 'field_mix' || $context == 'comment') {
    $no_collect_entries = ($context == 'field_mix')? TRUE: FALSE;
    //TODO: change this to tpl file
    echo theme_kaltura_contribution_wizard_field($theme_params, $field_id, $no_collect_entries, $kshow_id, $add_filter);
    exit();
  }
  if ($navigate_back === NULL) {
    $navigate_back = TRUE;
  }
  if (KalturaSettings_CW_UICONF_ID_SIMPLE == $ui_conf) {
    if (isset($write_output) && $write_output == 0)
    {
            return theme('kaltura_contribution_wizard_simple', $theme_params);
        }
        else
        {
            echo theme('kaltura_contribution_wizard_simple', $theme_params);
        }
  }
  else if ($kshow_id != "-2" && !$add_new) {
    echo theme('kaltura_contribution_wizard', $theme_params);
  }
  else {
    echo theme('kaltura_contribution_wizard_add', $theme_params, $navigate_back);
  }
  exit;
}

/*
 * theme the kaltura maintenance page
 *
 * this page is displayed whenever a try to create the $kaltura_client object fails
 */
function theme_kaltura_maintenance_page($text, $var) {
  return $text;
}


/*
 * theme for kaltura/contribution_wizard_field
 * in case we add content as a CCK field
 */
function theme_kaltura_contribution_wizard_field($vars) {
  //TODO: clean this up
  ctools_include('modal');
  ctools_include('ajax');
  $goto_url = kaltura_cw_destination();
  global $_kaltura_thumbnail_base_url;

  $javascript = '
    var entry_list = '. (($vars['no_collect_entries'] === TRUE)? '"'. $vars['kshow_id'] .'"': '-1') .';
    var goto_url = "'. $goto_url .'";
    function onContributionWizardAfterAddEntry(obj) {
      var str = obj[0]["entryId"];
      var type = obj[0]["mediaType"];
      var mediaTypes = [];
      mediaTypes[1] = \'Video\';
      mediaTypes[2] = \'Image\';
      mediaTypes[5] = \'Audio\';
      '.
        (($vars['no_collect_entries'] === TRUE)? '': 'if (entry_list == "-1") entry_list = str; else entry_list += str;') .'
         jQuery("#' . $vars['field_id'] . '-entryid input").val(str);
         jQuery("#' . $vars['field_id'] . '-media-type input").val(type);
         var t = \'<div class="title">Added \' +  mediaTypes[type] + \' </div><div class="kaltura_field_thumb"><img src="' . $_kaltura_thumbnail_base_url . '/entry_id/\' + str + \'"/><br/> <input type="button" title="remove item" class="remove_media" /></div>\'
          jQuery("#' . $vars['field_id'] . '-thumb-wrap").html(t);
          Drupal.attachBehaviors();
    }

    function onContributionWizardClose(modified) {
      if (modified == "0")
        modalContentClose
      else
        modalContentClose
    }
  ';

  $add_existing = '';
  $js  = '';
  if ($vars['field_id'] != 'edit-comment') {
    $js = 'jQuery(document).ready(function() { window.top.document.getElementById("kaltura_modal_iframe").className = ""; ';
    $js .= PHP_EOL .'window.top.document.getElementById("kaltura_modal_iframe").scrolling = "no"; });';
    $js .= PHP_EOL .'window.top.document.getElementById("modalbox").style.height = "380px";';
    $js .= PHP_EOL .'window.top.document.getElementById("kaltura_modal_iframe").height = "380";';
  }
  $flash_embed = '<div id="divKalturaCw"></div>
    <script type="text/javascript">
      var kso = new SWFObject("'. $vars['theme_params']['swfurl'] .'", "kalturaCw", "'. $vars['theme_params']['width'] .'", "'. $vars['theme_params']['height'] .'", "9", "#000000");
      kso.addParam("flashVars", "'. $vars['theme_params']['flashVarsStr'] .'");
      kso.addParam("allowScriptAccess", "always");
      kso.addParam("allowFullScreen", "TRUE");
      kso.addParam("allowNetworking", "all");
      kso.write("divKalturaCw");
    </script>
      ';

  //return theme("kaltura_modal", array("javascript" => $javascript . $js, "flashEmbed" => $add_existing . $flash_embed));
      //return  array("javascript" => $javascript . $js, "flashEmbed" => $add_existing . $flash_embed);
      $out['js'] =  $javascript . $js;
      drupal_add_js($out['js'], array('type' => 'inline', 'scope' =>'footer'));
      $out['html'] = '<div class="flash">' . $add_existing . $flash_embed . '</div>';
      return $out['html'];

}



/*
 * helper function to get embed options according to the "kaltura tag" parameters
 *
 * this function also calls the kaltura_use_widget (file kaltura.module) function which exposes a hook
 *
 * returns an array of embed options later injected into the embed tag
 */
function kaltura_get_embed_options($params) {
  switch ($params["align"]) {
    case 'r': $align = "right";
      break;
    case 'm': $align = "center";
      break;
    case 'l': $align = "left";
      break;
    default: $align = "";
      break;
  }

  if ($params['id']) {
    $div_id = $params['id'];
  }
  if ($params['custom_style']) {
    $custom_style = $params['custom_style'];
  }

  if ($_SERVER["SERVER_PORT"] == 443) {
    $protocol = "https://";
  }
  else {
    $protocol = "http://";
  }

  if ($params['autoplay']) {
    $autoplay = '&autoplay=1';
  }
  if ($params['uiconf_id']) {
    $uicid = $params['uiconf_id'];
    if (is_numeric($uicid))
    {
            $theme_uicid = $uicid;
    }
    else
    {
            $theme_uicid = TRUE;
        }
  }

  if ($params['widget_id']) {
    $widget_id = $params['widget_id'];
  }
  $wid = '_'. variable_get('kaltura_partner_id', '');
  $delivery = 'HTTP';

  $widescreen = '';
  if ($params["entry"]) {
    $uicid = kaltura_use_uiconf($uicid, 'entry', $theme_uicid, $params['media_type']);
    $swf_url = KalturaHelpers::getSwfUrlForWidget($wid  .'/entry_id/'. $params["entry"] .'/uiconf_id/'. $uicid);
    $media_id = $params["entry"];
    if ($params['media_type'] == 'video') {
          $delivery = variable_get('kaltura_video_entry_delivery_type', 'HTTP');
      if (variable_get('kaltura_video_entry_player_ratio', 0) == 1) {
        $widescreen = '&widescreen=1';
      }
    }
    elseif ($params['media_type'] == 'viewplaylist')
    {
                $delivery = variable_get('kaltura_viewplaylist_entry_delivery_type', 'HTTP');
    }

    $player_size = kaltura_calculate_player_size('entry', $params['size'], $params['width'], $params['height']);
  }
  elseif ($params["kid"]) {
    $uicid = kaltura_use_uiconf($uicid, 'mix', $theme_uicid);
    $kshow = TRUE;
    $swf_url = KalturaHelpers::getSwfUrlForWidget($wid  .'/kid/'. $params["kid"] .'/uiconf_id/'. $uicid);
    $media_id = $params["kid"];
    $player_size = kaltura_calculate_player_size('mix', $params['size'], $params['width'], $params['height']);
  }
  elseif ($params["mix"]) {
    $uicid = kaltura_use_uiconf($uicid, 'mix', $theme_uicid);
    $roughcut = TRUE;
    $swf_url = KalturaHelpers::getSwfUrlForWidget($wid  .'/entry_id/'. $params["mix"] .'/uiconf_id/'. $uicid);
    $media_id = $params["mix"];
    $player_size = kaltura_calculate_player_size('mix', $params['size'], $params['width'], $params['height']);
    $delivery = variable_get('kaltura_roughcut_mix_delivery_type', 'HTTP');
  }
  elseif ($params["comment"]) {
    $uicid = kaltura_use_uiconf($uicid, 'entry', $theme_uicid, 'comment');
    $swf_url = KalturaHelpers::getSwfUrlForWidget($wid  .'/entry_id/'. $params["comment"] .'/uiconf_id/'. $uicid);
    $media_id = $params["comment"];
    $player_size = kaltura_calculate_player_size('comment', $params['size'], $params['width'], $params['height']);
      $delivery = variable_get('kaltura_comment_delivery_type', 'HTTP');
}

  $finish_f = '';
  if ($params['finishF']) {
    $finish_f = '&finishF='. $params['finishF'];
  }

  $flash_vars_str = KalturaHelpers::flashVarsToString(KalturaHelpers::getKalturaPlayerFlashVars(""));
  $flash_vars_str .= "&externalInterfaceDisabled=false&layoutId=". $player_size['layout_id'] ."&                pd_original_url=". urlencode($protocol . $_SERVER["HTTP_HOST"] . request_uri()) . $widescreen . $finish_f . $autoplay;
  if ($delivery == 'RTMP')
  {
    $flash_vars_str .= "&streamerType=rtmp&streamerUrl=rtmp://rtmpakmi.kaltura.com/ondemand&rtmpFlavors=1";
  }

  return array(
    "flashVars" => $flash_vars_str,
    "height" => $player_size["height"],
    "width" => $player_size["width"],
    "custom_style" => $custom_style,
    "align" => $align,
    "media_id" => $media_id,
    "js_events" => $events,
    "wid" => $wid,
    "uiconf" => $uicid,
    "roughcut" => $roughcut,
    "kshow" => $kshow,
    "swfUrl" => $swf_url,
    "div_id" => $div_id
  );
}

/*
 * helper function that returns the player width and height according to letter
 * found in the "kaltura tag"
 */
function kaltura_calculate_player_size($type, $size, $width = 0, $height = 0) {
  if ($width > 0 && $height > 0) {
    return array('width' => $width, 'height' => $height, 'layout_id' => 'fullLarge');
  }
  switch ($type) {
    case 'entry':
      $variable_width = variable_get('kaltura_entry_width', '410');
      $variable_height = variable_get('kaltura_entry_height', '364');
      break;
    case 'mix':
      $variable_width = variable_get('kaltura_mix_width', '410');
      $variable_height = variable_get('kaltura_mix_height', '364');
      break;
    case 'comment':
      $variable_width = variable_get('kaltura_comment_width', '250');
      $variable_height = variable_get('kaltura_comment_height', '244');
      break;
  }
  return array('width' => $variable_width, 'height' => $variable_height, 'layout_id' => 'fullLarge');
}
